import 'dart:html';

import 'package:google_maps/google_maps.dart';

final cafe = LatLng(37.869085, -122.254775);

void main() {
  final panoramaOptions = StreetViewPanoramaOptions()
    ..position = cafe
    ..pov = (StreetViewPov()
      ..heading = 270
      ..pitch = 0)
    ..visible = true;
  final panorama =
      StreetViewPanorama(document.getElementById('pano'), panoramaOptions);

  panorama.onPanoChanged.listen((_) {
    document.getElementById('pano_cell').innerHtml = panorama.pano;
  });

  panorama.onLinksChanged.listen((_) {
    final linksTable = document.getElementById('links_table');
    linksTable.children.clear();
    final links = panorama.links;
    for (var i = 0; i < links.length; i++) {
      final row = TableRowElement();
      linksTable.children.add(row);
      final labelCell = TableCellElement()..innerHtml = '<b>Link: $i</b>';
      final valueCell = TableCellElement()..innerHtml = links[i].description;
      linksTable.children.add(labelCell);
      linksTable.children.add(valueCell);
    }
  });

  panorama.onPositionChanged.listen((_) {
    document.getElementById('position_cell').innerHtml = '${panorama.position}';
  });

  panorama.onPovChanged.listen((_) {
    final headingCell = document.getElementById('heading_cell');
    final pitchCell = document.getElementById('pitch_cell');
    headingCell.innerHtml = '${panorama.pov.heading}';
    pitchCell.innerHtml = '${panorama.pov.pitch}';
  });
}
